Codeforces 389D Fox and Minimal path【构造+二进制思维】好题!

来源:互联网 发布:苹果淘宝下载 编辑:程序博客网 时间:2024/05/18 19:35

转自:http://blog.csdn.net/mengxiang000000/article/details/53072307
B. Fox and Minimal path
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Fox Ciel wants to write a task for a programming contest. The task is: “You are given a simple undirected graph with n vertexes. Each its edge has unit length. You should calculate the number of shortest paths between vertex 1 and vertex 2.”

Same with some writers, she wants to make an example with some certain output: for example, her birthday or the number of her boyfriend. Can you help her to make a test case with answer equal exactly to k?
Input

The first line contains a single integer k (1 ≤ k ≤ 109).
Output

You should output a graph G with n vertexes (2 ≤ n ≤ 1000). There must be exactly k shortest paths between vertex 1 and vertex 2 of the graph.

The first line must contain an integer n. Then adjacency matrix G with n rows and n columns must follow. Each element of the matrix must be ‘N’ or ‘Y’. If Gij is ‘Y’, then graph G has a edge connecting vertex i and vertex j. Consider the graph vertexes are numbered from 1 to n.

The graph must be undirected and simple: Gii = ‘N’ and Gij = Gji must hold. And there must be at least one path between vertex 1 and vertex 2. It’s guaranteed that the answer exists. If there multiple correct answers, you can output any of them.
Examples
Input

2

Output

4
NNYY
NNYY
YYNN
YYNN

Input

9

Output

8
NNYYYNNN
NNNNNYYY
YNNNNYYY
YNNNNYYY
YNNNNYYY
NYYYYNNN
NYYYYNNN
NYYYYNNN

Input

1

Output

2
NY
YN

Note

In first example, there are 2 shortest paths: 1-3-2 and 1-4-2.

In second example, there are 9 shortest paths: 1-3-6-2, 1-3-7-2, 1-3-8-2, 1-4-6-2, 1-4-7-2, 1-4-8-2, 1-5-6-2, 1-5-7-2, 1-5-8-2.

题目大意:

让你构造出来一个图,里边包含N个点,并且保证从1到2的最短路的条数为K个,求一个可行解。

N必须小于等于1000。

思路:

1、一开始的思路是将给出的数K因子分解,但是想到如果K是一个很大的素数,那么结果是不可行的,因为题干要求点的数量小于等于1000.

2、然后考虑,无论一个数多大,都能用二进制数来表示,那么我们考虑将输入进来的K先转成二进制数。

比如21:10101

那么我们考虑将其弄成2^0+2^2+2^4即可,对应我们很容易搞出来2^4的图:
这里写图片描述

那么那么我们2^0,直接从3连出来一条分路,只要保证从1-3-分路-2的长度和从1到2的最短路长度相同即可:
这里写图片描述
那么2^2同理,我们从9分离出来一条分路即可(因为从1到9上边的路有4种走法,那么再从9连入20,那么就多出来4种走法):
!

#include <cstdio>#include <cstring>using namespace std;int f[1005][1005];int main(){    int k;    scanf("%d",&k);    int w[39],cnt=0;    while(k)    {        w[cnt++]=k%2;        k/=2;    }    f[1][3]=f[3][1]=1;    int now=3;    for(int i=1; i<cnt; i++)    {        f[now][now+1]=f[now+1][now]=1;        f[now][now+2]=f[now+2][now]=1;        f[now+1][now+3]=f[now+3][now+1]=1;        f[now+2][now+3]=f[now+3][now+2]=1;        now+=3;    }    int tmp=now+1;    f[now][2]=f[2][now]=1;    for(int i=0; i<(cnt-2)*2; i++)    {        f[tmp][tmp+1]=f[tmp+1][tmp]=1;        tmp++;    }    f[tmp][now]=f[now][tmp]=1;    int pos=now+1;    now=tmp;    int t=1;    for(int i=0; i<cnt; i++)    {        if(w[i]==1)        {            f[t*3][pos]=f[pos][t*3]=1;        }        t++;        pos+=2;    }    printf("%d\n",now);    for(int i=1; i<=now; i++)    {        for(int j=1; j<=now; j++)            if(f[i][j])                printf("Y");            else printf("N");        puts("");    }    return 0;}
阅读全文
0 0
原创粉丝点击